from abc import ABC
from typing import List, Any

import spacy

from experiment.sentence_wer_processor.sentence_wer_processor import SentenceWerProcessor


class SpacyDepTagSentenceWerProcessor(SentenceWerProcessor):
    _nlp: Any

    def __init__(
        self,
        model_name: str,
        gold_transcript_property_name: str,
        asr_property_name: str,
        alignment_property_name: str,
        wer_property_name: str,
        task_name: str,
        require_update: bool
    ):
        super().__init__(gold_transcript_property_name, asr_property_name, alignment_property_name, wer_property_name,
                         task_name, require_update)
        self._nlp = spacy.load(model_name)

    def process_text(self, text: str) -> List[str]:
        document = self._nlp(text)
        return [token.dep_ for token in document]
